using Model;

namespace TestModel;

public class PersonTest
{
    [Fact]
    public void TestFirstName_CorrectValue()
    {
        Person person = new Person("Chuck", "McGill");
        Assert.Equal("Chuck", person.FirstName);

        person.FirstName = "Jimmy";
        Assert.Equal("Jimmy", person.FirstName);
    }

    [Fact]
    public void TestFirstName_NullValue()
    {
        Person person = new Person("Jimmy", "McGill");
        Assert.Equal("Jimmy", person.FirstName);

        person.FirstName = null;
        Assert.Equal("Jane", person.FirstName);
    }

    [Fact]
    public void TestFirstName_EmptyValue()
    {
        Person person = new Person("Jimmy", "McGill");
        Assert.Equal("Jimmy", person.FirstName);

        person.FirstName = "";
        Assert.Equal("Jane", person.FirstName);
    }

    [Fact]
    public void TestFirstName_WhiteSpacesValue()
    {
        Person person = new Person("Jimmy", "McGill");
        Assert.Equal("Jimmy", person.FirstName);

        person.FirstName = "       ";
        Assert.Equal("Jane", person.FirstName);
    }

    [Theory]
    [InlineData("Jimmy", "Jimmy")]
    [InlineData("Jane", null)]
    [InlineData("Jane", "")]
    [InlineData("Jane", "     ")]
    public void TestFirstName(string expectedName, string inputName)
    {
        Person person = new Person("Chuck", "McGill");
        Assert.Equal("Chuck", person.FirstName);

        person.FirstName = inputName;
        Assert.Equal(expectedName, person.FirstName);
    }
}