﻿namespace Model;

public class NounoursManager
{
    private INounoursStore nounoursStore;

    private IEmailService emailService;

    public NounoursManager(INounoursStore nounoursStore, IEmailService emailService)
    {
        this.nounoursStore = nounoursStore;
        this.emailService = emailService;
    }

    public async Task<bool> AddNewNounours(Nounours nounours)
    {
        var result = await nounoursStore.Add(nounours);
        
        if(result == null) return false;

        try
        {
            await emailService.AskConfirmation(nounours);
        }
        catch
        {
            bool removed = await nounoursStore.Remove(nounours);
            if(!removed) throw new Exception("this should not happen...");
            return false;
        }

        return true;
    }
}
