using Model;

namespace UTests;

public class MockNounoursStore : INounoursStore
{
    public MockNounoursStore(bool canAdd, bool canRemove)
    {
        CanAdd  = canAdd;
        CanRemove  = canRemove;
    }

    private bool CanAdd {get; set; }
    private bool CanRemove {get; set; }

    public Nounours? AddedNounours { get; private set; }

    public Task<Nounours?> Add(Nounours nounours)
    {
        if(CanAdd)
        {
            AddedNounours = nounours;
            return Task.FromResult<Nounours?>(nounours);
        }
        else
        {
            return Task.FromResult<Nounours?>(null);
        }
    }

    public Task<bool> Remove(Nounours nounours)
    {
        if(CanRemove)
        {
            AddedNounours = null;
            return Task.FromResult(true);
        }
        else
        {
            return Task.FromResult(false);
        }
    }
}